<template>
  <v-chip
    v-if="mode === 'chip'"
    prepend-icon="mdi-currency-rub"
    class="text-gray-900"
  >
    <span v-if="currentProfit === 0">
      Бесплатно
    </span>

    <span v-else>
      {{ displayValue.rubles }}.{{ displayValue.penny }}
    </span>
  </v-chip>

  <section
    v-if="mode === 'display'"
    class="flex items-end"
  >
    <span
      v-if="currentProfit !== 0 || disableLabel"
      class="text-gray-500 mr-[1px] leading-none"
    >
      <v-icon
        icon="mdi-currency-rub"
        size="x-small"
      />
    </span>

    <span
      v-if="currentProfit !== 0 || disableLabel"
      class="leading-none text-2xl font-medium"
    >
      {{ displayValue.rubles }}
    </span>

    <span
      v-if="currentProfit === 0 && !disableLabel"
      class="leading-none text-lg text-gray-500 font-lighter"
    >
      Бесплатно
    </span>

    <span
      v-if="currentProfit !== 0 || disableLabel"
      class="leading-none text-gray-500 ml-[1px]"
    >
      {{ displayValue.penny }}
    </span>
  </section>

  <span v-if="mode === 'plain'">
    <span v-if="currentProfit === 0 && !disableLabel">
      Бесплатно
    </span>

    <span
      v-else
      class="inline-flex items-center"
    >
      {{ displayValue.rubles }}.{{ displayValue.penny }}

      <v-icon
        icon="mdi-currency-rub"
        size="x-small"
      />
    </span>
  </span>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue';

type ProfitDisplayMode = 'display' | 'chip' | 'plain';
type ProfitDisplayProps = {
  value: number | string;
  disableLabel?: boolean;
  mode?: ProfitDisplayMode;
}

const props = withDefaults(defineProps<ProfitDisplayProps>(), {
  disableLabel: false,
  mode: 'display',
});

const currentProfit = ref(parseFloat(String(props.value)));

const displayValue = computed(() => {
  const rubles = String(Math.trunc(currentProfit.value));

  const decimalPart = currentProfit.value - Math.floor(currentProfit.value);
  const penny = String(Math.round(decimalPart * 100)).padStart(2, '0');

  return { rubles, penny };
});

watch(() => props.value, value => {
  currentProfit.value = parseFloat(String(value));
});
</script>